module namespace javaclasses="Java classes identified as graphic components";

declare variable $javaclasses:names as xs:string* := ("JApplet", "JButton", "JCheckBox", "JCheckBoxMenuItem", "JColorChooser", "JComboBox", "JComponent", "JDesktopPane", "JDialog", "JEditorPane", "JFileChooser", "JFormattedTextField", "JFrame", "JInternalFrame", "JLabel", "JLayeredPane", "JList", "JMenu", "JMenuBar", "JMenuItem", "JOptionPane", "JPanel", "JPasswordField", "JPopupMenu", "JProgressBar", "JRadioButton", "JRadioButtonMenuItem", "JRootPane", "JScrollBar", "JScrollPane", "JSeparator", "JSlider", "JSpinner", "JSplitPane", "JTabbedPane", "JTable", "JTextArea", "JTextField", "JTextPane", "JToggleButton", "JToolBar", "JToolTip", "JTree", "JViewport", "JWindow");

declare variable $javaclasses:containers as xs:string* := ("JFrame", "JApplet", "JInternalFrame", "JPanel", "JDesktopPane", "JRootPane", "JScrollPane", "JSplitPane", "JTabbedPane");

declare variable $javaclasses:containees as xs:string* := ("JLabel", "JButton", "JToggleButton", "JCheckBox", "JRadioButton", "JComboBox", "JList", "JTextField", "JTextArea", "JScrollBar", "JSlider", "JProgressBar", "JFormattedTextField", "JPasswordField", "JSpinner", "JSeparator", "JTextPane", "JEditorPane", "JTree", "JTable", "JPanel", "JScrollPane", "JTabbedPane", "JSplitPane", "JToolBar");

declare variable $javaclasses:textenabled as xs:string* := ("JButton", "JCheckBox", "JEditorPane", "JFormattedTextField", "JLabel", "JPasswordField", "JRadioButton", "JTextArea", "JTextField", "JTextPane", "JToggleButton");

declare variable $javaclasses:actionperformedenabled as xs:string* := ("JButton"); (: also JCheckBox and JRadioButton, but yet :)

declare function javaclasses:isGraphicComponent($name as xs:string) as xs:boolean{
	if (fn:empty(index-of($javaclasses:names, $name))) then (
		fn:false()
	)else(
		fn:true()
	)
};

declare function javaclasses:isRootContainer($name as xs:string) as xs:boolean{
	if (fn:empty(index-of($javaclasses:containers, $name))) then (
		fn:false()
	)else(
		fn:true()
	)	
};

declare function javaclasses:isTextEnabled($name as xs:string) as xs:boolean{
	if (fn:empty(index-of($javaclasses:textenabled, $name))) then (
		fn:false()
	)else(
		fn:true()
	)	
};

declare function javaclasses:isActionPerformedEnabled($name as xs:string) as xs:boolean{
	if (fn:empty(index-of($javaclasses:actionperformedenabled, $name))) then (
		fn:false()
	)else(
		fn:true()
	)	
};
