module namespace wl="XMI Write Library";

declare namespace xmi="http://schema.omg.org/spec/XMI/2.1";
declare namespace uml="http://schema.omg.org/spec/UML/2.0";
declare namespace fn="http://www.w3.org/2005/xpath-functions";
declare namespace xs="http://www.w3.org/2001/XMLSchema";

declare function wl:class($useCase as node(), $generalizations as node()*, $stereotypes as node()*, $attributes as node()*, $attributeAsComposition as xs:boolean, $tags as node()*) as node(){
	document{
	<ownedMember isAbstract="{data($useCase/@isAbstract)}" isActive="false" isLeaf="{data($useCase/@isLeaf)}" name="{data(fn:replace($useCase/@name, " ", ""))}" visibility="public" xmi:id="{data(concat($useCase/@xmi:id,"TT"))}" xmi:type="uml:Class">
					<xmi:Extension xmi:Extender="Visual Paradigm for UML">
							<isRoot xmi:value="{data($useCase//isRoot/@xmi:value)}"/>
							<modelType value="Class"/>
							<businessModel xmi:value="{data($useCase//businessModel/@xmi:value)}"/>
							<qualityScore value="92"/>
							<qualityReason value="1&#9;1&#10;2&#9;2"/>
							{
								if($useCase/@xmi:type="uml:Actor")then(
									<appliedStereotype xmi:value="Class_Actor_id"/>
								)
								else()
							}
					</xmi:Extension>
					{
						if(fn:empty($attributes))then()
						else(
								for $a in $attributes
								return (
									if($attributeAsComposition)then(wl:getterAndSetter($a, fn:false()))
									else(wl:attribute($a) union (wl:getterAndSetter($a, fn:false())))
								)
						)
					}
					{
						if(fn:empty($tags)) then()
						else(
							
								for $t in $tags
								return (wl:attributeFromTags($t) union (wl:getterAndSetter($t, fn:true())))
							
						)
					}
					{
						if(fn:empty($generalizations)) then()
						else(
							for $y in $generalizations
							return wl:generalization($y)
						)
					}
					{
						if(fn:empty($stereotypes)) then()
						else(
							for $s in $stereotypes
							return wl:generalizationFromStereotype($s, $useCase/@xmi:id)
						)
					}
			</ownedMember>
	}
};

declare function wl:class($useCase as node(), $generalizations as node()*, $stereotypes as node()*, $attributes as node()*, $activities as node()*, $edges as node()*, $attributeAsComposition as xs:boolean, $tags as node()*) as node(){
	document{
	<ownedMember isAbstract="{data($useCase/@isAbstract)}" isActive="false" isLeaf="{data($useCase/@isLeaf)}" name="{data(fn:replace($useCase/@name, " ", ""))}" visibility="public" xmi:id="{data(concat($useCase/@xmi:id,"TT"))}" xmi:type="uml:Class">
					<xmi:Extension xmi:Extender="Visual Paradigm for UML">
							<isRoot xmi:value="{data($useCase//isRoot/@xmi:value)}"/>
							<modelType value="Class"/>
							<businessModel xmi:value="{data($useCase//businessModel/@xmi:value)}"/>
							<qualityScore value="92"/>
							<qualityReason value="1&#9;1&#10;2&#9;2"/>
							{
								if($useCase/@xmi:type="uml:Actor")then(
									<appliedStereotype xmi:value="Class_Actor_id"/>
								)
								else()
							}
					</xmi:Extension>
					{
						if(fn:empty($attributes))then()
						else(
								for $a in $attributes
								return (
									if($attributeAsComposition)then(wl:getterAndSetter($a, fn:false()))
									else(wl:attribute($a) union (wl:getterAndSetter($a, fn:false())))
								)
						)
					}
					{
						if(fn:empty($activities))then()
						else(
								for $a in $activities
								return (
									if($attributeAsComposition)then(wl:getterAndSetter($a, fn:false()))
									else(wl:attribute($a) union (wl:getterAndSetter($a, fn:false())))
								)
						)
					}
					{
						if(fn:empty($edges))then()
						else(
							for $edge in $edges
							return (
								if($attributeAsComposition)then(wl:getterAndSetter($edge, fn:false()))
								else(wl:attribute($edge) union (wl:getterAndSetter($edge, fn:false())))
							)
						)
					}
					{
						if(fn:empty($tags)) then()
						else(
							
								for $t in $tags
								return (wl:attributeFromTags($t) union (wl:getterAndSetter($t, fn:true())))
							
						)
					}
					{
						if(fn:empty($generalizations)) then()
						else(
							for $y in $generalizations
							return wl:generalization($y)
						)
					}
					{
						if(fn:empty($stereotypes)) then()
						else(
							for $s in $stereotypes
							return wl:generalizationFromStereotype($s, $useCase/@xmi:id)
						)
					}
			</ownedMember>
	}
};


declare function wl:operation($isAbstract as xs:string, $isLeaf as xs:string, $isQuery as xs:string, $name as xs:string, $ownerScope as xs:string, $visibility as xs:string, $id as xs:string, $returnParam as item()*, $inoutParam as item()*, $hasInoutParam as xs:boolean) as node(){
		document{
			<ownedOperation isAbstract="{data($isAbstract)}" isLeaf="{data($isLeaf)}" isQuery="{data($isQuery)}" name="{data($name)}" ownerScope="{data($ownerScope)}" visibility="{data($visibility)}" xmi:id="{data($id)}" xmi:type="uml:Operation">
				{
					(:1=$isReturn, 2=$name, 3=$type, 4=$id:)
					wl:parameter($returnParam[1], $returnParam[2], $returnParam[3], $returnParam[4])
				}
				{
					if($hasInoutParam)then(
						(:1=$isReturn, 2=$name, 3=$type, 4=$id:)
						wl:parameter($inoutParam[1], $inoutParam[2], $inoutParam[3], $inoutParam[4])
					)
					else()
				}
				<xmi:Extension xmi:Extender="Visual Paradigm for UML">
					<returnTypeDocumentation xmi:value=""/>
					<qualityScore value="-1"/>
				</xmi:Extension>
			</ownedOperation>
		}
};

declare function wl:parameter($kind as xs:string, $name as xs:string?, $type as xs:string?, $id as xs:string?) as node(){
		document{
			<ownedParameter kind="{data($kind)}" name="{data(fn:replace($name, "^.*?]", ""))}" type="{data($type)}" xmi:id="{data($id)}" xmi:type="uml:Parameter"/>
		}
};

declare function wl:association($x as node()?, $orig as node()?, $dest as node(), $id as xs:string, $name as xs:string, $isAbstract as xs:boolean, $isDerived as xs:boolean, $isLeaf as xs:boolean, $isInclude as xs:boolean, $isStereotype as xs:boolean, $pos as xs:string?) as node(){
	document{
		<ownedMember isAbstract="{data($isAbstract)}" isDerived="{data($isDerived)}" isLeaf="{data($isLeaf)}" name="" xmi:id="{data(concat($id,if($isStereotype)then(concat($pos, "TT"))else("TT")))}" xmi:type="uml:Association">
			{
				if(fn:not($isStereotype))then(
						wl:associationEnd(if($isInclude)then($dest)else($x), $id, "none", concat($id,'TT'), xs:integer(1), fn:false(), "", concat(if($isInclude)then($orig/@xmi:id)else($orig/@type),'TT'), $isStereotype)
						union
						wl:associationEnd(if($isInclude)then($dest)else($x), $id, "composite", concat($id,'TT'), xs:integer(2), fn:true(), lower-case(replace($name,' ', "")), concat(if($isInclude)then($dest/@addition)else($dest/@type),'TT'), $isStereotype)
				)
				else(
						wl:associationEnd((), concat($id, $pos), "none", concat($id, $pos, 'TT'), xs:integer(1), fn:false(), "", concat($id,'TT'), $isStereotype)
						union
						wl:associationEnd((), concat($id, $pos), "composite", concat($id, $pos, 'TT'), xs:integer(2), fn:true(), lower-case(replace($name,' ', "")), fn:replace($dest/@xmi:value, "^.*?_", ""), $isStereotype)
				)
			}
		<xmi:Extension extender="Visual Paradigm for UML">
			<qualityScore value="100"/>
		</xmi:Extension>
    </ownedMember>
	}
};

declare function wl:associationEnd($y as node()?, $id as xs:string, $aggregation as xs:string, $association as xs:string, $index as xs:integer, $isNavigable as xs:boolean, $name as xs:string, $type as xs:string, $isStereotype as xs:boolean) as node()*{
	wl:memberEnd($y, $id, $index, $isStereotype)
	union
	document{
		<ownedEnd aggregation="{data($aggregation)}" association="{data($association)}" isNavigable="{data($isNavigable)}" name="{data($name)}" type="{data($type)}" visibility="private" xmi:id="{data(concat($id,"TT", "ME", $index cast as xs:string))}" xmi:type="uml:Property">
			<xmi:Extension xmi:Extender="Visual Paradigm for UML">
				<associationEnd/>
				<qualifier name="" xmi:id="{data(concat($id,"TT", "OE", $index cast as xs:string))}" xmi:type="qualifier">
					<xmi:Extension extender="Visual Paradigm for UML">
						<qualityScore value="-1"/>
					</xmi:Extension>
				</qualifier>
				<qualityScore value="-1"/>
			</xmi:Extension>
		</ownedEnd>
	}
};

declare function wl:memberEnd($y as node()?, $id as xs:string, $index as xs:integer, $isStereotype as xs:boolean){
	if($isStereotype)then(
			document{
				<memberEnd xmi:idref="{data(concat($id,"TT", "ME", $index cast as xs:string))}"/>
			}
	)
	else(
				document{
				<memberEnd xmi:idref="{data(concat($y/@xmi:id,"TT", "ME", $index cast as xs:string))}"/>
			}
	)
};

declare function wl:attribute($y as node()) as node(){
		document{
			<ownedAttribute aggregation="none" name="{data(fn:replace(lower-case(replace($y/@name," ", "")), "^.*?]", ""))}" ownerScope="instance" type="{data(fn:replace(($y/xmi:Extension/appliedStereotype)/@xmi:value, "^.*?_", ""))}" visibility="private" xmi:id="{data(concat($y/@xmi:id,"TTAt"))}" xmi:type="uml:Property">
				<xmi:Extension xmi:Extender="Visual Paradigm for UML">
					<attribute/>
					<isVisible xmi:value="true"/>
					<qualityScore value="-1"/>
				</xmi:Extension>
			</ownedAttribute>
		}
};

declare function wl:attributeFromTags($y as node()) as node()*{
		for $b in $y/xmi:Extension/taggedValue
		where (fn:contains($b/@tag, 'ComplementaryClass'))
		return(
					document{
							<ownedAttribute aggregation="none" name="{data(concat(lower-case(fn:substring($b/@value, 1, 2)), lower-case(replace($y/@name," ", ""))))}" ownerScope="instance" type="{data(fn:concat($b/@value, "_id"))}" visibility="private" xmi:id="{data(concat($b/@xmi:id,"TTAt"))}" xmi:type="uml:Property">
									<xmi:Extension xmi:Extender="Visual Paradigm for UML">
										<attribute/>
										<isVisble xmi:value="true"/>
										<qualityScore value="-1"/>
									</xmi:Extension>
							</ownedAttribute>
					}
		)
	
};

declare function wl:generalization($y as node()) as node(){
		document{
			<generalization general="{data(concat($y/@general,"TT"))}" name="" xmi:id="{data(concat($y/@xmi:id,"TT"))}" xmi:type="uml:Generalization">
				<xmi:Extension extender="Visual Paradigm for UML">
					<qualityScore value="100"/>
				</xmi:Extension>
			</generalization>
		}
};

declare function wl:generalizationFromStereotype($stereotype as node(), $id as xs:string) as node(){
		document{
			<generalization general="{data(fn:replace($stereotype/@xmi:value, "^.*?_", ""))}" name="" xmi:id="{data(concat(fn:replace($stereotype/@xmi:value, "^.*?_", ""), concat("TTgen", fn:substring($id, 1, 4))))}" xmi:type="uml:Generalization">
				<xmi:Extension extender="Visual Paradigm for UML">
					<qualityScore value="100"/>
				</xmi:Extension>
			</generalization>
		}
};

declare function wl:dataType($y as node()?) as node(){
			if(fn:compare($y/@xmi:type, "uml:Stereotype")=0) then(
				document{
					if(fn:compare($y/@name, "")=0)then()
					else(
						<ownedMember name="{data($y/@name)}" visibility="public" xmi:id="{data(fn:replace($y/@xmi:id, "^.*?_", ""))}" xmi:type="uml:Class"/>
					)
				}
			)
			else(
				document{
					if(fn:compare($y/@value, "")=0)then()
					else(
						<ownedMember name="{data($y/@value)}" visibility="public" xmi:id="{data(fn:concat($y/@value, "_id"))}" xmi:type="uml:Class"/>
					)
				}
			)
};

declare function wl:dataType($name as xs:string, $visibility as xs:string, $id as xs:string) as node(){
	document{
		<ownedMember name="{data($name)}" visibility="{data($visibility)}" xmi:id="{data($id)}" xmi:type="uml:DataType"/>
	}
};

declare function wl:useCasesStereotypes() as node(){
		document{
			<ownedMember name="Actor" xmi:id="Class_Actor_id" xmi:type="uml:Stereotype"/>
		}
};

declare function wl:getterAndSetter($x as node(), $wasTag as xs:boolean) as node()*{
	if($wasTag)then(
			wl:getterAndSetterForTag($x)
	)
	else(
		wl:getterAndSetterForAttribute($x)
	)
};

declare function wl:getterAndSetterForAttribute($attribute as node()) as node()*{
			let $operationName:= replace($attribute/@name," ", "")
			let $param1:= ("return", "", fn:replace(($attribute/xmi:Extension/appliedStereotype)/@xmi:value, "^.*?_", ""), concat($attribute/@xmi:id,"TTOp1P1"))
			return(
				wl:getAttribute($param1, $attribute, $operationName) 
			)
			union(
				let $operationName := replace($attribute/@name," ", "")
				let $param1:= ("return", "", "void_id", concat($attribute/@xmi:id,"TTOp2P1"))
				let $param2:= ("inout", lower-case(replace($attribute/@name," ", "")), fn:replace(fn:replace(($attribute/xmi:Extension/appliedStereotype)/@xmi:value, "^.*?_", ""), "^.*?]", ""), concat($attribute/@xmi:id,"TTOp2P2"))
				return(
					wl:setAttribute($param1, $param2, $attribute, $operationName)
				)
			) 
};

declare function wl:getterAndSetterForTag($x as node()) as node()*{
	for $b in $x/xmi:Extension/taggedValue
	where (fn:contains($b/@tag, 'ComplementaryClass'))
	return(
				let $operationName := concat(fn:substring($b/@value, 1, 2), lower-case(replace($x/@name," ", "")))
				let $param1:= ("return", "", concat($b/@value, "_id"), concat($b/@xmi:id,"TTOp1P1"))
				return(
					wl:getAttribute($param1, $b, $operationName) 
				)
				union(
					let $operationName:=concat(fn:substring($b/@value, 1, 2), lower-case(replace($x/@name," ", "")))
					let $param1:= ("inout", concat(lower-case(fn:substring($b/@value, 1, 2)), lower-case(replace($x/@name," ", ""))), concat($b/@value, "_id"), concat($b/@xmi:id,"TTOp2P2"))
					let $param2:= ("return", "", "void_id", concat($b/@xmi:id,"TTOp2P1"))
					return(
						wl:setAttribute($param1, $param2, $b, $operationName)
					)			
				)		
		)
};

declare function wl:getAttribute($returnParam as item()*, $tag as node(), $operationName as xs:string) as node()*{
		wl:operation("false", "false", "false", concat("get",  fn:replace($operationName, "^.*?]", "")), "instance", "public", concat($tag/@xmi:id,"TTOp1"), $returnParam, (), false())
};

declare function wl:setAttribute($inoutParam as item()*, $returnParam as item()*, $tag as node(), $operationName as xs:string) as node()*{
		wl:operation("false", "false", "false", concat("set", fn:replace($operationName, "^.*?]", "")), "instance", "public", concat($tag/@xmi:id,"TTOp2"), $returnParam, $inoutParam, true())
};