/*****************************************************************************
 * This file is part of the Prolog Development Tools (ProDT)
 *
 * Author: Claudio Cancinos
 * WWW: https://sourceforge.net/projects/prodevtools
 * Copyright (C): 2008, Claudio Cancinos
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this program; If not, see <http://www.gnu.org/licenses/>
 ****************************************************************************/
package ar.com.tadp.prolog.core.compiler;

import java.util.ArrayList;
import java.util.Collection;
import java.util.List;

/**
 * 
 * @author Claudio
 * 
 */
public class CompilerOutput {
	private int exitStatus;
	private String output;
	private Collection<CompilerOutputItem> fErrors = new ArrayList<CompilerOutputItem>();
	private List exceptions;

	public CompilerOutput(final int exitStatus, final String output, final List exceptions) {
		this.exitStatus = exitStatus;
		this.output = output;
		this.exceptions = exceptions;
	}

	public CompilerOutput() {
		// placeholder constructor
	}

	public String toString() {
		return "Compiler output [ " + exceptions.size() + " Exceptions ]\n" + output + "\n" + fErrors;
	}

	public int getExitStatus() {
		return exitStatus;
	}

	public String getOutput() {
		return output;
	}

	public Collection<CompilerOutputItem> getErrors() {
		return new ArrayList<CompilerOutputItem>(fErrors);
	}

	public List getExceptions() {
		return exceptions;
	}

	public void addError(CompilerOutputItem item) {
		fErrors.add(item);
	}

}
