/*****************************************************************************
 * This file is part of the Prolog Development Tools (ProDT)
 *
 * Author: Claudio Cancinos
 * WWW: https://sourceforge.net/projects/prodevtools
 * Copyright (C): 2008, Claudio Cancinos
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this program; If not, see <http://www.gnu.org/licenses/>
 ****************************************************************************/
package ar.com.tadp.prolog.core.completion.templates;

import org.eclipse.dltk.ui.templates.ScriptTemplateAccess;
import org.eclipse.dltk.ui.templates.ScriptTemplatePreferencePage;
import org.eclipse.dltk.ui.text.ScriptSourceViewerConfiguration;
import org.eclipse.jface.text.IDocument;

import ar.com.tadp.prolog.core.PrologCorePlugin;
import ar.com.tadp.prolog.core.ui.PrologSimpleSourceViewerConfiguration;
import ar.com.tadp.prolog.core.ui.editor.PrologPartitions;
import ar.com.tadp.prolog.core.ui.editor.PrologTextTools;


/**
 * @author ccancino
 *
 */
public class PrologCodeTemplatesPreferencePage extends
		ScriptTemplatePreferencePage {

	protected ScriptSourceViewerConfiguration createSourceViewerConfiguration() {
		return new PrologSimpleSourceViewerConfiguration(getTextTools().getColorManager(), getPreferenceStore(), null,
				PrologPartitions.PROLOG_PARTITIONING, false);
	}

	protected void setDocumentParticioner(IDocument document) {
		getTextTools().setupDocumentPartitioner(document, PrologPartitions.PROLOG_PARTITIONING);
	}
	protected void setPreferenceStore() {
		setPreferenceStore(PrologCorePlugin.getDefault().getPreferenceStore());
	}
	protected ScriptTemplateAccess getTemplateAccess() {
		return PrologTemplateAccess.getInstance();
	}
	private PrologTextTools getTextTools() {
		return PrologCorePlugin.getDefault().getTextTools();
	}	
}
