/*****************************************************************************
 * This file is part of the Prolog Development Tools (ProDT)
 *
 * Author: Claudio Cancinos
 * WWW: https://sourceforge.net/projects/prodevtools
 * Copyright (C): 2008, Claudio Cancinos
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this program; If not, see <http://www.gnu.org/licenses/>
 ****************************************************************************/
package ar.com.tadp.prolog.core.completion.templates;

import org.eclipse.dltk.ui.templates.ScriptTemplateAccess;
import org.eclipse.jface.preference.IPreferenceStore;

import ar.com.tadp.prolog.core.PrologCorePlugin;

/**
 * @author ccancino
 *
 */
public class PrologTemplateAccess extends ScriptTemplateAccess {
	private static final String CUSTOM_TEMPLATES_KEY = "ar.com.tadp.dtlk.prolog.Templates";
 
	private static PrologTemplateAccess instance;
 
	public static PrologTemplateAccess getInstance() {
		if (instance == null) {
			instance = new PrologTemplateAccess();
		}
 
		return instance;
	}
 
	protected String getContextTypeId() {
		return PrologUniversalTemplateContextType.CONTEXT_TYPE_ID;
	}
	protected String getCustomTemplatesKey() {
		return CUSTOM_TEMPLATES_KEY;
	}
 
	protected IPreferenceStore getPreferenceStore() {
		return PrologCorePlugin.getDefault().getPreferenceStore();
	}
	
}
