/*****************************************************************************
 * This file is part of the Prolog Development Tools (ProDT)
 *
 * Author: Claudio Cancinos
 * WWW: https://sourceforge.net/projects/prodevtools
 * Copyright (C): 2008, Claudio Cancinos
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this program; If not, see <http://www.gnu.org/licenses/>
 ****************************************************************************/
package ar.com.tadp.prolog.core.parser;

import org.eclipse.dltk.compiler.IElementRequestor.MethodInfo;
import org.eclipse.dltk.compiler.IElementRequestor.TypeInfo;
import org.eclipse.dltk.compiler.ISourceElementRequestor;
import org.eclipse.dltk.compiler.SourceElementRequestVisitor;
import org.eclipse.dltk.compiler.env.ISourceModule;
import org.eclipse.dltk.core.AbstractSourceElementParser;
import org.eclipse.dltk.core.ISourceModuleInfoCache.ISourceModuleInfo;

import ar.com.tadp.prolog.core.PrologNature;

/**
 * @author ccancino
 * 
 */
public class PrologSourceElementParser extends AbstractSourceElementParser {

	//TODO REMOVE THE a AND RETURN NULL IN PrologSourceParser TO HAVE THIS MODEL CREATED
	public void aparseSourceModule(ISourceModule module, ISourceModuleInfo astCache) {
		ISourceElementRequestor requestor = getRequestor();

		requestor.enterModule();
		TypeInfo info = new TypeInfo();
		String elementName = module.getModelElement().getElementName();
		info.name = elementName.substring(0, elementName.indexOf("."));

		requestor.enterType(info);
		
		this.createMethod(requestor, 0,  11, "mother_child", "trude", "sally");
		this.createMethod(requestor, 30, 41, "father_child", "tom", "sally");
		this.createMethod(requestor, 57, 68, "father_child", "tom", "erica");
		this.createMethod(requestor, 84, 95, "father_child", "mike", "tom");
		this.createMethod(requestor, 115, 121, "sibling", "X", "Y");
		this.createMethod(requestor, 179, 190, "parent_child", "X", "Y");
		this.createMethod(requestor, 222, 233, "parent_child", "X", "Y");
		
		requestor.exitType(0);
		requestor.exitModule(0);
	}
	
	private void createMethod(ISourceElementRequestor requestor, int start, int end, String methodName,	String... parameterNames) {
		MethodInfo methodInfo = new MethodInfo();
		methodInfo.name = methodName;
		methodInfo.parameterNames = parameterNames;
		methodInfo.nameSourceStart = start;
		methodInfo.nameSourceEnd = end;
		requestor.enterMethod(methodInfo);
		requestor.exitMethod(0);
		
	}


	protected SourceElementRequestVisitor createVisitor() {
		return new PrologSourceElementRequestor(getRequestor());
	}


	protected String getNatureId() {
		return PrologNature.PROLOG_NATURE;
	}

}
